'use strict'

const SignalServer = require('./controller/signalserver.js');
const Connector = require('./controller/connector.js');
const Encoder = require('./util/encoder.js');
const SaseulJS = require('saseul');
const Saseul = new SaseulJS();

module.exports = class Guardee {

    signalserver;
    connector;
    encoder = Encoder;

    /**
     * initiate guardee instance
     * @param signalserver_host: guardee signal server host
     * @param signalserver_key: guardee signal server key
     * @param connect_option: option for peer to peer connection (wrtc for nodeJS)
     */
    constructor({ signalserver_host = null, signalserver_key = null, connect_option = { initiator: true, wrtc: null } }) {
        try {
            if(!window.guardee) window.guardee = this;
            this.signalserver = new SignalServer(signalserver_host, signalserver_key);
            this.connector = new Connector({
                signalserver: this.signalserver,
                initiator: connect_option.initiator,
                wrtc: connect_option.wrtc
            });
        } catch (e) {
            throw e;
        }
    }

}
