'use strict'

const ConnectionDataBodyFactory = require("../connectiondatabodyfactory");

module.exports = class ChunkBody extends ConnectionDataBodyFactory {

    static allowed = ['sign_tx', 'send_tx'];
    static allowedState = ['chunk_start', 'chunk_data', 'chunk_end'];
    static allowedResult = ['success', 'failed'];

    constructor({type, state, body}) {
        try {
            if(!ChunkBody.allowed.includes(type)) throw `Invalid type: ${type}`;
            if(!ChunkBody.allowedState.includes(state)) throw `Invalid state: ${state}`;
            super({type, body});
        } catch (e) {
            throw e;
        }
    }

}