'use strict'

const ChunkBody = require("./chunkbody");

module.exports = class ChunkEndBody extends ChunkBody {

    constructor({type, result, sentCount, failedCount, timestamp}) {
        try {
            if(result && !ChunkBody.allowedResult.includes(result)) throw `Invalid result: ${result}`;
            if(sentCount && typeof sentCount !== 'number') throw `Invalid sentCount type: ${typeof sentCount}`;
            if(failedCount && typeof failedCount !== 'number') throw `Invalid failedCount type: ${typeof failedCount}`;
            super({type, body: { state: 'chunk_end', result, sentCount, failedCount, timestamp }});
        } catch (e) {
            throw e;
        }
    }

}