'use strict'

const ConnectionDataBodyFactory = require("../connectiondatabodyfactory");

module.exports = class ConnectBody extends ConnectionDataBodyFactory {

    static allowedResult = ['success', 'failed'];

    /**
     *
     * @param result connect result
     * @param connectionId
     * @param peerId
     */
    constructor({result = 'failed', connectionId, peerId}) {
        try {
            if(!ConnectBody.allowedResult.includes(result)) throw `Invalid result: ${result}`;
            super({type:'connect', body: {result, connectionId, peerId}});
        } catch (e) {
            throw e;
        }
    }

}