'use strict'

const moment = require("moment");

module.exports = class ConnectionDataBodyFactory {

    object;
    type;
    keys = ['type'];

    constructor({type = '', body}) {
        try {
            if(typeof type !== 'string') throw `Invalid type type: ${typeof type}`;
            if(typeof body !== 'object') throw `Invalid body type: ${typeof body}`;

            if(!body.timestamp) body.timestamp = moment.now();
            this.type = type;
            for (const key in body) {
                if(key === 'type') throw 'Cannot apply "type" as key';
                if(body[key] !== undefined) {
                    this[key] = body[key];
                    this.keys.push(key);
                }
            }
        } catch (e) {
            throw e;
        }
    }

    Object() {
        try {
            const obj = {};
            this.keys.forEach(key => {
                obj[key] = this[key];
            });
            return obj;
        } catch (e) {
            throw e;
        }
    }

    Stringify() {
        try {
            return JSON.stringify(this.Object());
        } catch (e) {
            throw e;
        }
    }

}