'use strict'

const Util = require("../util/util");

module.exports = class ConnectionEvent {

    static allowed = [
        'genesis_connection',
        'genesis_offer',
        'genesis_offer_register',
        'genesis_offer_cancel',
        'genesis_answer_received',
        'genesis_answer_set',
        'error',
        'ready',
        'disconnect',
        'request',
        'response',
        'chunk',
        'chunk_start',
        'chunk_data',
        'chunk_end',
    ];
    detail;
    name;
    event;

    constructor(name, detail = {}) {
        try {
            if(typeof name !== 'string') throw `Invalid name type: ${typeof name}`;
            if(typeof detail !== 'object') throw `Invalid detail type: ${typeof detail}`;
            if(!ConnectionEvent.allowed.includes(name)) throw `Invalid name: ${name}`;

            this.name = name;
            this.detail = detail;

            if(Util.IsBrowser()) this.event = new CustomEvent(name, {detail});
            else this.event = { name, detail };

        } catch (e) {
            throw e;
        }
    }

}